# wxStringTokenizer Class Reference
[Data Structures]

`#include <wx/tokenzr.h>`

Inheritance diagram for wxStringTokenizer:
[legend]

## Detailed Description

wxStringTokenizer helps you to break a string up into a number of tokens.

It replaces the standard C function `strtok()` and also extends it in a number of ways.

To use this class, you should create a wxStringTokenizer object, give it the string to tokenize and also the delimiters which separate tokens in the string (by default, white space characters will be used).

Then wxStringTokenizer::GetNextToken() may be called repeatedly until wxStringTokenizer::HasMoreTokens() returns false.

For example:

        wxStringTokenizer tokenizer("first:second:third:fourth", ":");
        while ( tokenizer.HasMoreTokens() )
        {
            wxString token = tokenizer.GetNextToken();

            // process token here
        }

##

Library: wxBase

Category: Data Structures

See also:
  wxStringTokenize()

## Public Member Functions
| wxStringTokenizer ()
| Default constructor.
| wxStringTokenizer (const wxString &str, const wxString &delims=" \t\r\n", wxStringTokenizerMode mode=wxTOKEN_DEFAULT)
| Constructor.
size_t | CountTokens () const
| Returns the number of tokens remaining in the input string.
wxChar | GetLastDelimiter () const
| Returns the delimiter which ended scan for the last token returned by GetNextToken() or `NUL` if there had been no calls to this function yet or if it returned the trailing empty token in wxTOKEN_RET_EMPTY_ALL mode.
wxString | GetNextToken ()
| Returns the next token or empty string if the end of string was reached.
size_t | GetPosition () const
| Returns the current position (i.e.
wxString | GetString () const
| Returns the part of the starting string without all token already extracted.
bool | HasMoreTokens () const
| Returns true if the tokenizer has further tokens, false if none are left.
void | SetString (const wxString &to_tokenize, const wxString &delims=" \t\r\n", wxStringTokenizerMode mode=wxTOKEN_DEFAULT)
| Initializes the tokenizer.

List of all members.

## Constructor & Destructor Documentation

wxStringTokenizer::wxStringTokenizer | ( |  | ) |

Default constructor.

You must call SetString() before calling any other methods.

wxStringTokenizer::wxStringTokenizer | ( | const wxString & | str,
|  | const wxString & | delims = `" \t\r\n"`,
|  | wxStringTokenizerMode | mode = `wxTOKEN_DEFAULT` |
| ) |  |  |

Constructor.

Pass the string to tokenize, a string containing delimiters, and the mode specifying how the string should be tokenized.

See also:
  SetString()

## Member Function Documentation

size_t wxStringTokenizer::CountTokens | ( |  | ) | const

Returns the number of tokens remaining in the input string.

The number of tokens returned by this function is decremented each time GetNextToken() is called and when it reaches 0, HasMoreTokens() returns false.

wxChar wxStringTokenizer::GetLastDelimiter | ( |  | ) | const

Returns the delimiter which ended scan for the last token returned by GetNextToken() or `NUL` if there had been no calls to this function yet or if it returned the trailing empty token in wxTOKEN_RET_EMPTY_ALL mode.

Since:
  2.7.0

wxString wxStringTokenizer::GetNextToken | ( |  | ) |

Returns the next token or empty string if the end of string was reached.

size_t wxStringTokenizer::GetPosition | ( |  | ) | const

Returns the current position (i.e.

one index after the last returned token or 0 if GetNextToken() has never been called) in the original string.

wxString wxStringTokenizer::GetString | ( |  | ) | const

Returns the part of the starting string without all token already extracted.

bool wxStringTokenizer::HasMoreTokens | ( |  | ) | const

Returns true if the tokenizer has further tokens, false if none are left.

void wxStringTokenizer::SetString | ( | const wxString & | to_tokenize,
|  | const wxString & | delims = `" \t\r\n"`,
|  | wxStringTokenizerMode | mode = `wxTOKEN_DEFAULT` |
| ) |  |  |

Initializes the tokenizer.

Pass the string to tokenize, a string containing delimiters, and the mode specifying how the string should be tokenized.

|  | [ top ]